/***************************************************************************
 *   Copyright (C) 2006 by Stefano Zingarini   *
 *   stefano@xiaprojects.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef XEPLUGIN_GMAIL_H
#define XEPLUGIN_GMAIL_H

#include <qobject.h>
#include <qstring.h>
#include <qimage.h>
#include <qxml.h>
#include <qdom.h>
#include <qtimer.h>
#include <qpixmap.h>
#include <kiconloader.h>
#include <libkxdocker.h>

class QPixmap;
class QFile;

/**
@author Stefano
*/
class GMail : public gPluginSDK
{
Q_OBJECT
public:
    GMail(QObject *parent = 0, const char *name = 0);
	QObject *   Respawn(QObject *);
    ~GMail();

protected:
//	QObject			*xGDocker;
//	QObject			*xGIcon;
//	QImage			*xImgSource;
//	const QDomNodeList	*xXMLIconConfig;
//	QString			IconsPath;
//	QString			ToolTip;
	QString			overlay_none;
	QString			overlay_incoming;
	QImage			overlay_incomingImage;
	QImage			overlay_noneImage;
	QString			incomingIcon;
	QString			warningIcon;
	QPixmap			BasePixmap;
	QPixmap			IncomingPixmap;
	QPixmap			warningPixmap;

//	QPixmap			BufferPixmap;
	//int			lastNum;
	//int			eNum;
	//int			internalStatus;
	int			seconds;
	int			NotebookLED;
	QString			folderName;
//	QStringList		PluginInformations;
	QStringList		folders;
	int			iMiniText;
	int			warningIncoming;
	QFile *mailFile;
public slots:
    void xGetParameterList(QStringList *);
    void xPaint(int nEmails);
    void xApplyCfg();
    void xGetParameter(const QString, QString&);
    void xSetupParameter(const QString, const QString);
    void xStart();
    void xStop();
    void polling();
    void xGetParameterType(const QString &, QString &);

protected:
    void loadImages();
};

#endif
